## softether-vpn 4.29.9680

=== debian/changelog ===
softether-vpn (0:4.29.9680-rtm~20210718074950.40+wheezy) unstable; urgency=medium

  [ Mario Fetka ]
  * Bump

  [ jenkins-debian-glue Autobuilder ]
  * SNAPSHOT autobuild for unreleased 0:4.29.9680-rtm via jenkins-debian-
    glue.

 -- jenkins-debian-glue Autobuilder <jenkins@debbuild.disconnected-by-peer.at>  Sun, 18 Jul 2021 09:49:50 +0200

softether-vpn (0:4.04.9412-rtm) unstable; urgency=low

  * Testing debianization

 -- Dmitry Orlov <me@mosquito.su>  Tue, 4 Feb 2014 20:24:43 +0000

## softether-vpn 5.01.9674%2Bgit20200806%2B8181039%2Bdfsg3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project("SoftEther VPN"
  VERSION 5.01.9674
  LANGUAGES C
)

set(TOP_DIRECTORY ${CMAKE_SOURCE_DIR})
set(BUILD_DIRECTORY ${CMAKE_BINARY_DIR})

# We define a dedicated variable because CMAKE_BUILD_TYPE can have different
# configurations than "Debug" and "Release", such as "RelWithDebInfo".
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(BUILD_TYPE "Debug")
else()
  set(BUILD_TYPE "Release")
endif()

# Check that submodules are present only if source was downloaded with git
if(EXISTS "${TOP_DIRECTORY}/.git" AND NOT EXISTS "${TOP_DIRECTORY}/src/Mayaqua/3rdparty/cpu_features/CMakeLists.txt")
    message (FATAL_ERROR "Submodules are not initialized. Run\n\tgit submodule update --init --recursive")
endif()

# Compare ${PROJECT_VERSION} and src/CurrentBuild.txt
file(READ ${TOP_DIRECTORY}/src/CurrentBuild.txt CurrentBuild)

string(REGEX MATCH "VERSION_MAJOR ([0-9]+)" temp ${CurrentBuild})
string(REGEX REPLACE "VERSION_MAJOR ([0-9]+)" "\\1" CurrentBuild_MAJOR ${temp})
string(REGEX MATCH "VERSION_MINOR ([0-9]+)" temp ${CurrentBuild})
string(REGEX REPLACE "VERSION_MINOR ([0-9]+)" "\\1" CurrentBuild_MINOR ${temp})
string(REGEX MATCH "VERSION_BUILD ([0-9]+)" temp ${CurrentBuild})
string(REGEX REPLACE "VERSION_BUILD ([0-9]+)" "\\1" CurrentBuild_BUILD ${temp})

if(NOT ${PROJECT_VERSION} VERSION_EQUAL "${CurrentBuild_MAJOR}.${CurrentBuild_MINOR}.${CurrentBuild_BUILD}")
  message (FATAL_ERROR "PROJECT_VERSION does not match to src/CurrentBuild.txt")
endif()

if(UNIX)
  include(GNUInstallDirs)

  include(CheckIncludeFile)
  Check_Include_File(sys/auxv.h HAVE_SYS_AUXV)
  if(EXISTS "/lib/systemd/system")
    set(CMAKE_INSTALL_SYSTEMD_UNITDIR "/lib/systemd/system" CACHE STRING "Where to install systemd unit files")
  endif()
endif()

configure_file("${TOP_DIRECTORY}/AUTHORS.TXT" "${TOP_DIRECTORY}/src/bin/hamcore/authors.txt" COPYONLY)

# Date and time
string(TIMESTAMP DATE_DAY "%d" UTC)
string(TIMESTAMP DATE_MONTH "%m" UTC)
string(TIMESTAMP DATE_YEAR "%Y" UTC)
string(TIMESTAMP TIME_HOUR "%H" UTC)
string(TIMESTAMP TIME_MINUTE "%M" UTC)
string(TIMESTAMP TIME_SECOND "%S" UTC)

message(STATUS "Build date: ${DATE_DAY}/${DATE_MONTH}/${DATE_YEAR}")
message(STATUS "Build time: ${TIME_HOUR}:${TIME_MINUTE}:${TIME_SECOND}")

add_subdirectory(src)

if(UNIX)
  # Packaging
  set(CPACK_COMPONENTS_ALL common vpnserver vpnclient vpnbridge vpncmd)
  set(CPACK_PACKAGE_DIRECTORY ${BUILD_DIRECTORY})
  set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
  set(CPACK_PACKAGE_VENDOR "SoftEther")
  set(CPACK_PACKAGE_NAME "softether")
  set(CPACK_PACKAGE_DESCRIPTION_FILE "${TOP_DIRECTORY}/description")
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "SoftEther VPN is an open-source cross-platform multi-protocol VPN program, created as an academic project in the University of Tsukuba.")

  # DEB
  if(BUILD_TYPE STREQUAL "Debug")
    set(CPACK_DEBIAN_PACKAGE_DEBUG ON)
  endif()

  set(CPACK_DEB_COMPONENT_INSTALL ON)
  set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
  set(CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT")
  set(CPACK_DEBIAN_PACKAGE_SECTION "net")
  set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Unknown")

  # RPM
  set(CPACK_RPM_COMPONENT_INSTALL ON)
  set(CPACK_RPM_FILE_NAME "RPM-DEFAULT")
  set(CPACK_RPM_PACKAGE_GROUP "Applications/Internet")
  set(CPACK_RPM_PACKAGE_LICENSE "ASL 2.0")

  # Exclude system directories
  if(CPACK_GENERATOR STREQUAL "RPM")
    execute_process(
        COMMAND rpm -ql filesystem
        COMMAND tr \n \;
        OUTPUT_VARIABLE CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION
        ERROR_QUIET)
  endif()

  include(CPack)
endif()

## softether-vpn 4.44-9807

=== debian/changelog ===
softether-vpn (4.44-9807-rtm+0~20250808122313.54+bookworm~1.gbpf945c9) unstable; urgency=medium

  ** SNAPSHOT build @f945c945a00d3a939215df04fd1bfd898076ae8c **

  [ geos_one ]
  * New upstream version 4.44-9807
  * add gcc 14 patches

 -- jenkins-debian-glue Autobuilder <jenkins@debdev.disconnected-by-peer.at>  Fri, 08 Aug 2025 14:23:13 +0200

softether-vpn (4.44-9807-rtm) unstable; urgency=medium

  [ Mario Fetka ]
  * Bump

  [ geos_one ]
  * New upstream version 4.44-9807-rtm

 -- root <mario.fetka@disconnected-by-peer.at>  Fri, 08 Aug 2025 12:14:30 +0200

=== debian/control ===
Source: softether-vpn
Section: net
Priority: optional
Maintainer: Dmitry Orlov <me@mosquito.su>
Build-Depends: debhelper (>= 7.0.50~), libncurses-dev, linux-libc-dev, libssl-dev , libreadline-dev, build-essential, dh-exec, zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://www.softether.org/

Package: softether-vpnbridge
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, softether-vpncmd
Section: net
Description: VPN Bridge daemon
 An Open-Source Free Cross-platform Multi-protocol VPN Program, as an academic project from University of Tsukuba.
 SoftEther VPN ("SoftEther" means "Software Ethernet") is one of the world's most
 powerful and easy-to-use multi-protocol VPN software.
 It runs on Windows, Linux, Mac, FreeBSD and Solaris.
 SoftEther VPN is open source. You can use SoftEther for any
 personal or commercial use for free charge.
 SoftEther VPN is an optimum alternative to
 OpenVPN and Microsoft's VPN servers. SoftEther VPN
 has a clone-function of OpenVPN Server.
 You can integrate from OpenVPN to SoftEther VPN smoothly.
 SoftEther VPN is faster than OpenVPN.
 SoftEther VPN also supports Microsoft SSTP VPN for Windows Vista / 7 / 8.

Package: softether-vpnclient
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, softether-vpncmd
Section: net
Description: VPN Client daemon
 An Open-Source Free Cross-platform Multi-protocol VPN Program, as an academic project from University of Tsukuba.
 SoftEther VPN ("SoftEther" means "Software Ethernet") is one of the world's most
 powerful and easy-to-use multi-protocol VPN software.
 It runs on Windows, Linux, Mac, FreeBSD and Solaris.
 SoftEther VPN is open source. You can use SoftEther for any
 personal or commercial use for free charge.
 SoftEther VPN is an optimum alternative to
 OpenVPN and Microsoft's VPN servers. SoftEther VPN
 has a clone-function of OpenVPN Server.
 You can integrate from OpenVPN to SoftEther VPN smoothly.
 SoftEther VPN is faster than OpenVPN.
 SoftEther VPN also supports Microsoft SSTP VPN for Windows Vista / 7 / 8.

Package: softether-vpncmd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: net
Description: Command line utils
 An Open-Source Free Cross-platform Multi-protocol VPN Program, as an academic project from University of Tsukuba.
 SoftEther VPN ("SoftEther" means "Software Ethernet") is one of the world's most
 powerful and easy-to-use multi-protocol VPN software.
 It runs on Windows, Linux, Mac, FreeBSD and Solaris.
 SoftEther VPN is open source. You can use SoftEther for any
 personal or commercial use for free charge.
 SoftEther VPN is an optimum alternative to
 OpenVPN and Microsoft's VPN servers. SoftEther VPN
 has a clone-function of OpenVPN Server.
 You can integrate from OpenVPN to SoftEther VPN smoothly.
 SoftEther VPN is faster than OpenVPN.
 SoftEther VPN also supports Microsoft SSTP VPN for Windows Vista / 7 / 8.

Package: softether-vpnserver
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, softether-vpncmd
Section: net
Description: VPN Server daemon
 An Open-Source Free Cross-platform Multi-protocol VPN Program, as an academic project from University of Tsukuba.
 SoftEther VPN ("SoftEther" means "Software Ethernet") is one of the world's most
 powerful and easy-to-use multi-protocol VPN software.
 It runs on Windows, Linux, Mac, FreeBSD and Solaris.
 SoftEther VPN is open source. You can use SoftEther for any
 personal or commercial use for free charge.
 SoftEther VPN is an optimum alternative to
 OpenVPN and Microsoft's VPN servers. SoftEther VPN
 has a clone-function of OpenVPN Server.
 You can integrate from OpenVPN to SoftEther VPN smoothly.
 SoftEther VPN is faster than OpenVPN.
 SoftEther VPN also supports Microsoft SSTP VPN for Windows Vista / 7 / 8.

## softether-vpn 5.01.9674%2Bgit20200806%2B8181039%2Bdfsg2

=== debian/changelog ===
softether-vpn (5.01.9674+git20200806+8181039+dfsg2-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:02:21 +1100

softether-vpn (5.01.9674+git20200806+8181039+dfsg2-2build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:23:43 +0000

softether-vpn (5.01.9674+git20200806+8181039+dfsg2-2build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Wed, 24 Nov 2021 11:24:33 +0100

softether-vpn (5.01.9674+git20200806+8181039+dfsg2-2) unstable; urgency=medium

  * Install the hamcore link to the vpnclient package as well
    (actually closes: #973403).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 03 Dec 2020 10:35:09 +0100

softether-vpn (5.01.9674+git20200806+8181039+dfsg2-1) unstable; urgency=medium

  * Update Files-Excluded, revert erroneour removal of upstream files
    (Closes: #973403).
  * Add gitlab-ci.yml.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 16 Nov 2020 14:16:59 +0100

softether-vpn (5.01.9674+git20200806+8181039+dfsg-2) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #972496).

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 19 Oct 2020 14:14:55 +0200

softether-vpn (5.01.9674+git20200806+8181039+dfsg-1) unstable; urgency=low

  * Initial upload (Closes: #968447).

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 15 Aug 2020 22:54:32 +0200

## softether-vpn 5.01.9674+git20200806+8181039+dfsg2

=== src/Cedar/CMakeLists.txt ===
file(GLOB SOURCES_CEDAR "*.c")
file(GLOB HEADERS_CEDAR "*.h")

if(WIN32)
  enable_language(CXX)
  file(GLOB SOURCES_CEDAR_CPP "*.cpp")
endif()

if(WIN32)
  add_library(cedar STATIC ${SOURCES_CEDAR} ${SOURCES_CEDAR_CPP} ${HEADERS_CEDAR})
else()
  add_library(cedar SHARED ${SOURCES_CEDAR} ${SOURCES_CEDAR_CPP} ${HEADERS_CEDAR})
endif()

set_target_properties(cedar
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

if(WIN32)
  set_target_properties(cedar
    PROPERTIES
    COMPILE_PDB_NAME "cedar"
    COMPILE_PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  target_include_directories(cedar PRIVATE winpcap)
endif()

if(UNIX)
  find_library(LIB_READLINE readline)
  find_package(Curses REQUIRED)

  target_link_libraries(cedar PRIVATE ${LIB_READLINE} ${CURSES_LIBRARIES})

  if(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    target_link_libraries(cedar PRIVATE mayaqua pcap)
  endif()
endif()

# Version
add_definitions(-DCEDAR_VERSION_MAJOR=${PROJECT_VERSION_MAJOR} -DCEDAR_VERSION_MINOR=${PROJECT_VERSION_MINOR} -DCEDAR_VERSION_BUILD=${PROJECT_VERSION_PATCH})

# Builder
if(UNIX)
  add_definitions(-DBUILDER_NAME="$ENV{USER}")
elseif(WIN32)
  add_definitions(-DBUILDER_NAME="$ENV{USERNAME}")
endif()

cmake_host_system_information(RESULT BUILDER_HOSTNAME QUERY HOSTNAME)

add_definitions(-DBUILD_PLACE="${BUILDER_HOSTNAME}")

# Remove leading 0 from date and time
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_DAY "${DATE_DAY}")
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_MONTH "${DATE_MONTH}")
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_YEAR "${DATE_YEAR}")
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_HOUR "${TIME_HOUR}")
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_MINUTE "${TIME_MINUTE}")
string(REGEX REPLACE "^0([^ ]*)" "\\1" BUILD_SECOND "${TIME_SECOND}")

add_definitions(-DBUILD_DATE_D=${BUILD_DAY} -DBUILD_DATE_M=${BUILD_MONTH} -DBUILD_DATE_Y=${BUILD_YEAR})
add_definitions(-DBUILD_DATE_HO=${BUILD_HOUR} -DBUILD_DATE_MI=${BUILD_MINUTE} -DBUILD_DATE_SE=${BUILD_SECOND})

if(UNIX)
  install(TARGETS cedar
    COMPONENT "common"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )
endif()

=== src/Mayaqua/CMakeLists.txt ===
file(GLOB SOURCES_MAYAQUA "*.c")
file(GLOB HEADERS_MAYAQUA "*.h")

if(WIN32)
  add_library(mayaqua STATIC ${SOURCES_MAYAQUA} ${HEADERS_MAYAQUA})
else()
  add_library(mayaqua SHARED ${SOURCES_MAYAQUA} ${HEADERS_MAYAQUA})
endif()

target_include_directories(mayaqua PUBLIC .)

set_target_properties(mayaqua
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)

target_link_libraries(mayaqua PRIVATE OpenSSL::SSL OpenSSL::Crypto ZLIB::ZLIB)

if(WIN32)
  set_target_properties(mayaqua
    PROPERTIES
    COMPILE_PDB_NAME "mayaqua"
    COMPILE_PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )
endif()

if(UNIX)
  find_package(Threads REQUIRED)

  # In some cases libiconv is not included in libc
  find_library(LIB_ICONV iconv)

  find_library(LIB_RT rt)

  target_link_libraries(mayaqua PRIVATE Threads::Threads)

  if (CMAKE_SYSTEM_PROCESSOR MATCHES "^(armv7l|aarch64|s390x)$" OR NOT HAVE_SYS_AUXV OR SKIP_CPU_FEATURES)
    add_definitions(-DSKIP_CPU_FEATURES)
  else()
    add_subdirectory(3rdparty/cpu_features)
    set_property(TARGET cpu_features PROPERTY POSITION_INDEPENDENT_CODE ON)
    target_link_libraries(mayaqua PRIVATE cpu_features)
  endif()

  if(LIB_RT)
    target_link_libraries(mayaqua PRIVATE rt)
  endif()

  if(LIB_ICONV)
    target_link_libraries(mayaqua PRIVATE ${LIB_ICONV})
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL "SunOS")
    target_link_libraries(mayaqua PRIVATE nsl socket)
  endif()

  install(TARGETS mayaqua
    COMPONENT "common"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )
endif()

=== src/hamcorebuilder/CMakeLists.txt ===
add_executable(hamcorebuilder hamcorebuilder.c)

target_link_libraries(hamcorebuilder cedar mayaqua)

=== src/vpnbridge/CMakeLists.txt ===
set(COMPONENT_NAME "Bridge")
set(COMPONENT_INTERNAL_NAME "vpnbridge")

if(WIN32)
  add_executable(vpnbridge WIN32 vpnbridge.c)

  set_target_properties(vpnbridge
    PROPERTIES
    PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  get_filename_component(COMPONENT_FILE_NAME vpnbridge NAME)
  set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

  configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
  target_sources(vpnbridge PRIVATE "vpnbridge.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

  if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
    target_sources(vpnbridge PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
  else()
    target_sources(vpnbridge PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
  endif()
else()
  add_executable(vpnbridge vpnbridge.c)
endif()

set_target_properties(vpnbridge
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpnbridge cedar mayaqua)

if(UNIX)
  # Copy binary and "hamcore.se2" to /usr/lib(exec)/softether/, install launch script and systemd service
  install(TARGETS vpnbridge
    COMPONENT "vpnbridge"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnbridge"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )

  install(FILES "${BUILD_DIRECTORY}/hamcore.se2"
    COMPONENT "vpnbridge"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnbridge"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )

  install_wrapper_script("vpnbridge")
  if(NOT "${CMAKE_INSTALL_SYSTEMD_UNITDIR}" STREQUAL "")
    install_unit_file("vpnbridge")
  endif()
endif()

=== src/vpnclient/CMakeLists.txt ===
set(COMPONENT_NAME "Client")
set(COMPONENT_INTERNAL_NAME "vpnclient")

if(WIN32)
  add_executable(vpnclient WIN32 vpncsvc.c vpncsvc.h)

  set_target_properties(vpnclient
    PROPERTIES
    PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  get_filename_component(COMPONENT_FILE_NAME vpnclient NAME)
  set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

  configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
  target_sources(vpnclient PRIVATE "vpnclient.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

  if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
    target_sources(vpnclient PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
  else()
    target_sources(vpnclient PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
  endif()
else()
  add_executable(vpnclient vpncsvc.c vpncsvc.h)
endif()

set_target_properties(vpnclient
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpnclient cedar mayaqua)

if(UNIX)
  # Copy binary and "hamcore.se2" to /usr/lib(exec)/softether/, install launch script and systemd service
  install(TARGETS vpnclient
    COMPONENT "vpnclient"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnclient"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )

  install(FILES "${BUILD_DIRECTORY}/hamcore.se2"
    COMPONENT "vpnclient"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnclient"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )

  install_wrapper_script("vpnclient")
  if(NOT "${CMAKE_INSTALL_SYSTEMD_UNITDIR}" STREQUAL "")
    install_unit_file("vpnclient")
  endif()
endif()

=== src/vpnserver/CMakeLists.txt ===
set(COMPONENT_NAME "Server")
set(COMPONENT_INTERNAL_NAME "vpnserver")

if(WIN32)
  add_executable(vpnserver WIN32 vpnserver.c)

  set_target_properties(vpnserver
    PROPERTIES
    PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  get_filename_component(COMPONENT_FILE_NAME vpnserver NAME)
  set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

  configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
  target_sources(vpnserver PRIVATE "vpnserver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

  if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
    target_sources(vpnserver PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
  else()
    target_sources(vpnserver PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
  endif()
else()
  add_executable(vpnserver vpnserver.c)
endif()

set_target_properties(vpnserver
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpnserver cedar mayaqua)

if(UNIX)
  # Copy binary and "hamcore.se2" to /usr/lib(exec)/softether/, install launch script and systemd service
  install(TARGETS vpnserver
    COMPONENT "vpnserver"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnserver"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )

  install(FILES "${BUILD_DIRECTORY}/hamcore.se2"
    COMPONENT "vpnserver"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpnserver"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )

  install_wrapper_script("vpnserver")
  if(NOT "${CMAKE_INSTALL_SYSTEMD_UNITDIR}" STREQUAL "")
    install_unit_file("vpnserver")
  endif()
endif()

=== src/vpnsetup/CMakeLists.txt ===
if(NOT WIN32)
  message(FATAL_ERROR "VPN Setup is available only for Windows.")
endif()

set(COMPONENT_NAME "Setup")
set(COMPONENT_INTERNAL_NAME "vpnsetup")

add_executable(vpnsetup WIN32 vpnsetup.c vpnsetup.rc)

get_filename_component(COMPONENT_FILE_NAME vpnsetup NAME)
set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
target_sources(vpnsetup PRIVATE "vpnsetup.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
  target_sources(vpnsetup PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
else()
  target_sources(vpnsetup PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
endif()

set_target_properties(vpnsetup
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpnsetup cedar mayaqua)

=== debian/control ===
Source: softether-vpn
Section: net
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libncurses5-dev,
 libreadline-dev,
 libssl-dev,
 zlib1g-dev,
Standards-Version: 4.5.0
Homepage: https://www.softether.org/
Vcs-Browser: https://salsa.debian.org/debian/softether-vpn
Vcs-Git: https://salsa.debian.org/debian/softether-vpn.git

Package: softether-vpnserver
Architecture: any
Depends:
 softether-common,
 softether-vpncmd,
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: multiprotocol VPN program (server daemon)
 SoftEther is an open-source cross-platform multi-protocol VPN program.
 .
 SoftEther supports:
 .
  * SSL-VPN, OpenVPN, IPsec, L2TP, MS-SSTP, L2TPv3, EtherIP
  * VPN over ICMP and VPN over DNS
  * Ethernet-bridging (L2) and IP-routing (L3) over VPN
  * Embedded dynamic DNS and NAT traversal
  * AES 256-bit and RSA 4096-bit encryption
  * RADIUS and NT domain user authentication
  * X.509 client certificates
  * Packet logging
  * Web GUI
 .
 This package ships the VPN server daemon.

Package: softether-vpnclient
Architecture: any
Depends:
 softether-common,
 softether-vpncmd,
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: multiprotocol VPN program (client)
 SoftEther is an open-source cross-platform multi-protocol VPN program.
 .
 SoftEther supports:
 .
  * SSL-VPN, OpenVPN, IPsec, L2TP, MS-SSTP, L2TPv3, EtherIP
  * VPN over ICMP and VPN over DNS
  * Ethernet-bridging (L2) and IP-routing (L3) over VPN
  * Embedded dynamic DNS and NAT traversal
  * AES 256-bit and RSA 4096-bit encryption
  * RADIUS and NT domain user authentication
  * X.509 client certificates
  * Packet logging
  * Web GUI
 .
 This package ships the VPN client.

Package: softether-vpncmd
Architecture: any
Depends:
 softether-common,
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: multiprotocol VPN program (command-line tools)
 SoftEther is an open-source cross-platform multi-protocol VPN program.
 .
 SoftEther supports:
 .
  * SSL-VPN, OpenVPN, IPsec, L2TP, MS-SSTP, L2TPv3, EtherIP
  * VPN over ICMP and VPN over DNS
  * Ethernet-bridging (L2) and IP-routing (L3) over VPN
  * Embedded dynamic DNS and NAT traversal
  * AES 256-bit and RSA 4096-bit encryption
  * RADIUS and NT domain user authentication
  * X.509 client certificates
  * Packet logging
  * Web GUI
 .
 This package ships the command-line tools used to control SoftEther.

Package: softether-vpnbridge
Architecture: any
Depends:
 softether-common,
 softether-vpncmd,
 ${misc:Depends},
 ${shlibs:Depends}
Section: net
Description: multiprotocol VPN program (bridge daemon)
 SoftEther is an open-source cross-platform multi-protocol VPN program.
 .
 SoftEther supports:
 .
  * SSL-VPN, OpenVPN, IPsec, L2TP, MS-SSTP, L2TPv3, EtherIP
  * VPN over ICMP and VPN over DNS
  * Ethernet-bridging (L2) and IP-routing (L3) over VPN
  * Embedded dynamic DNS and NAT traversal
  * AES 256-bit and RSA 4096-bit encryption
  * RADIUS and NT domain user authentication
  * X.509 client certificates
  * Packet logging
  * Web GUI
 .
 This package ships the VPN bridge daemon.

Package: softether-common
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Section: net
Description: multiprotocol VPN program (common files)
 SoftEther is an open-source cross-platform multi-protocol VPN program.
 .
 SoftEther supports:
 .
  * SSL-VPN, OpenVPN, IPsec, L2TP, MS-SSTP, L2TPv3, EtherIP
  * VPN over ICMP and VPN over DNS
  * Ethernet-bridging (L2) and IP-routing (L3) over VPN
  * Embedded dynamic DNS and NAT traversal
  * AES 256-bit and RSA 4096-bit encryption
  * RADIUS and NT domain user authentication
  * X.509 client certificates
  * Packet logging
  * Web GUI
 .
 This package ships the common files used by other SoftEther packages.

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none, repack, compression=xz, repacksuffix=+dfsg, dversionmangle=s/@DEB_EXT@//" \
 https://github.com/SoftEtherVPN/SoftEtherVPN \
 refs/tags/([\d]+)\.([\d.]+)

opts="mode=git, pgpmode=none, pretty=5.01.9674+git%cd+%h, repack, compression=xz, repacksuffix=+dfsg, dversionmangle=s/@DEB_EXT@//" \
 https://github.com/SoftEtherVPN/SoftEtherVPN \
 HEAD

## softether-vpn 5.01.9674+git20200806+8181039+dfsg3

=== src/CMakeLists.txt ===
if(UNIX)
  # Creates wrapper scripts and installs them in the user's binaries directory, which is usually "/usr/local/bin".
  # This is required because symlinks use the folder they are in as working directory.
  #
  # The actual wrapper script needs to be generated at install time, not build time, because it depends on the
  # installation prefix. This is especially important when generating packages (rpm/deb) where the prefix is
  # changed from /usr to /usr/local for the install step.
  #
  # The placeholder is needed to satisfy the "install" dependency scanner which runs early.
  #
  macro(install_wrapper_script component)
    file(GENERATE OUTPUT ${BUILD_DIRECTORY}/${component}.sh
      CONTENT "# placeholder\n"
    )

    install(CODE "file(WRITE ${BUILD_DIRECTORY}/${component}.sh \"#!/bin/sh\nexec \${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/softether/${component}/${component} \\\"$@\\\"\n\")"
     COMPONENT ${component}
    )

    install(PROGRAMS ${BUILD_DIRECTORY}/${component}.sh
      COMPONENT ${component}
      DESTINATION bin
      RENAME ${component}
    )
  endmacro(install_wrapper_script)

  # Same approach for systemd unit files
  #
  macro(install_unit_file component)
    file(GENERATE OUTPUT ${BUILD_DIRECTORY}/softether-${component}.service
      CONTENT "# placeholder\n"
    )

    install(CODE "set(DIR \"\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}\")\nconfigure_file(${TOP_DIRECTORY}/systemd/softether-${component}.service ${BUILD_DIRECTORY}/softether-${component}.service)"
      COMPONENT ${component}
    )

    install(FILES ${BUILD_DIRECTORY}/softether-${component}.service
      COMPONENT ${component}
      DESTINATION ${CMAKE_INSTALL_SYSTEMD_UNITDIR}
      PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
    )
  endmacro(install_unit_file)
endif()

if(BUILD_TYPE STREQUAL "Debug")
  add_definitions(-D_DEBUG -DDEBUG)
else()
  add_definitions(-DNDEBUG -DVPN_SPEED)
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(COMPILER_ARCHITECTURE "x64")
  add_definitions(-DCPU_64)
else()
  set(COMPILER_ARCHITECTURE "x86")
endif()

add_definitions(-D_REENTRANT -DREENTRANT -D_THREAD_SAFE -D_THREADSAFE -DTHREAD_SAFE -DTHREADSAFE -D_FILE_OFFSET_BITS=64)

# Add /src to the include paths
include_directories(.)

if(WIN32)
  add_definitions(-DWIN32 -D_WINDOWS -D_CRT_SECURE_NO_WARNINGS)
endif()

if(UNIX)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char")
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g")
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2")

  add_definitions(-DUNIX)

  if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    add_definitions(-DUNIX_LINUX)
    if("$ENV{USE_MUSL}" STREQUAL "YES")
      add_definitions(-DUNIX_LINUX_MUSL)
    endif()
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    add_definitions(-DUNIX_BSD -DBRIDGE_BPF)
    include_directories(SYSTEM /usr/local/include)
    link_directories(SYSTEM /usr/local/lib)
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    add_definitions(-DUNIX_BSD -DUNIX_OPENBSD)
    include_directories(SYSTEM /usr/local/include)
    link_directories(SYSTEM /usr/local/lib)
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL "SunOS")
    add_definitions(-DUNIX_SOLARIS -DNO_VLAN)
  endif()

  if(${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    add_definitions(-DUNIX_BSD -DUNIX_MACOS -DBRIDGE_PCAP)
  endif()

  # custom db, log, pid directory for Unix
  set(SE_DBDIR "" CACHE STRING "Directory where config files are saved")
  set(SE_LOGDIR "" CACHE STRING "Directory where log files are written")
  set(SE_PIDDIR "" CACHE STRING "Directory where PID files are put")

  if(SE_DBDIR)
    add_definitions(-DSE_DBDIR="${SE_DBDIR}")
  endif()

  if(SE_LOGDIR)
    add_definitions(-DSE_LOGDIR="${SE_LOGDIR}")
  endif()

  if(SE_PIDDIR)
    add_definitions(-DSE_PIDDIR="${SE_PIDDIR}")
  endif()
endif()

# Cedar communication module
add_subdirectory(Cedar)

# Mayaqua kernel
add_subdirectory(Mayaqua)

# hamcorebuilder utility
add_subdirectory(hamcorebuilder)

# vpnserver
add_subdirectory(vpnserver)

# vpnclient
add_subdirectory(vpnclient)

# vpnbridge
add_subdirectory(vpnbridge)

# vpncmd
add_subdirectory(vpncmd)

# vpntest
add_subdirectory(vpntest)

# hamcore.se2 archive file
add_custom_target(hamcore-archive-build
  ALL
  COMMAND hamcorebuilder "${TOP_DIRECTORY}/src/bin/hamcore/" "${BUILD_DIRECTORY}/hamcore.se2"
  DEPENDS hamcorebuilder
  COMMENT "Building hamcore.se2 archive file..."
  VERBATIM
)

if(WIN32)
  # PenCore
  add_subdirectory(PenCore)
  add_dependencies(hamcore-archive-build PenCore)

  # vpndrvinst
  add_subdirectory(vpndrvinst)
  add_dependencies(hamcore-archive-build vpndrvinst)

  # vpnsmgr
  add_subdirectory(vpnsmgr)

  # vpncmgr
  add_subdirectory(vpncmgr)

  # vpnsetup
  add_subdirectory(vpnsetup)
endif()

if(UNIX)
  # Print message after installing the targets
  install(CODE "message(\"\n----------------------------------------------------------------------------------------------------------------------------\")")
  install(CODE "message(\"Build completed successfully.\n\")")
  install(CODE "message(\"Execute 'vpnserver start' to run the SoftEther VPN Server background service.\")")
  install(CODE "message(\"Execute 'vpnbridge start' to run the SoftEther VPN Bridge background service.\")")
  install(CODE "message(\"Execute 'vpnclient start' to run the SoftEther VPN Client background service.\")")
  install(CODE "message(\"Execute 'vpncmd' to run the SoftEther VPN Command-Line Utility to configure VPN Server, VPN Bridge or VPN Client.\")")
  install(CODE "message(\"----------------------------------------------------------------------------------------------------------------------------\n\")")
endif()

=== src/vpncmd/CMakeLists.txt ===
set(COMPONENT_NAME "Command Line Management Utility")
set(COMPONENT_INTERNAL_NAME "vpncmd")

add_executable(vpncmd vpncmd.c)

set_target_properties(vpncmd
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

if(WIN32)
  set_target_properties(vpncmd
    PROPERTIES
    PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  get_filename_component(COMPONENT_FILE_NAME vpncmd NAME)
  set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

  configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
  target_sources(vpncmd PRIVATE "vpncmd.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

  if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
    target_sources(vpncmd PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
  else()
    target_sources(vpncmd PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
  endif()
endif()

target_link_libraries(vpncmd cedar mayaqua)

if(UNIX)
  # Copy binary and "hamcore.se2" to /usr/lib(exec)/softether/, install launch script
  install(TARGETS vpncmd
    COMPONENT "vpncmd"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpncmd"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  )

  install(FILES "${BUILD_DIRECTORY}/hamcore.se2"
    COMPONENT "vpncmd"
    DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/softether/vpncmd"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  )

  install_wrapper_script("vpncmd")
endif()

=== src/vpncmgr/CMakeLists.txt ===
if(NOT WIN32)
  message(FATAL_ERROR "VPN Client Manager is available only for Windows.")
endif()

set(COMPONENT_NAME "Client Manager")
set(COMPONENT_INTERNAL_NAME "vpncmgr")

add_executable(vpncmgr WIN32 vpncmgr.c vpncmgr.rc)

get_filename_component(COMPONENT_FILE_NAME vpncmgr NAME)
set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
target_sources(vpncmgr PRIVATE "vpncmgr.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
  target_sources(vpncmgr PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
else()
  target_sources(vpncmgr PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
endif()

set_target_properties(vpncmgr
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpncmgr cedar mayaqua)

=== src/vpndrvinst/CMakeLists.txt ===
if(NOT WIN32)
  message(FATAL_ERROR "VPN Driver Installer is available only for Windows.")
endif()

set(COMPONENT_NAME "Driver Installer")
set(COMPONENT_INTERNAL_NAME "vpndrvinst")

add_executable(vpndrvinst WIN32 vpndrvinst.c vpndrvinst.h)

get_filename_component(COMPONENT_FILE_NAME vpndrvinst NAME)
set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
target_sources(vpndrvinst PRIVATE "vpndrvinst.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

# Fixes manifest authoring error c1010001
set_target_properties(vpndrvinst PROPERTIES LINK_FLAGS "/MANIFESTUAC:level='requireAdministrator'")

if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
  target_sources(vpndrvinst PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_admin.manifest")
else()
  target_sources(vpndrvinst PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_admin.manifest")
endif()

set_target_properties(vpndrvinst
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${TOP_DIRECTORY}/src/bin/hamcore"
  LIBRARY_OUTPUT_DIRECTORY "${TOP_DIRECTORY}/src/bin/hamcore"
  RUNTIME_OUTPUT_DIRECTORY "${TOP_DIRECTORY}/src/bin/hamcore"
  PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpndrvinst cedar mayaqua)

=== src/vpnsmgr/CMakeLists.txt ===
if(NOT WIN32)
  message(FATAL_ERROR "VPN Server Manager is available only for Windows.")
endif()

set(COMPONENT_NAME "Server Manager")
set(COMPONENT_INTERNAL_NAME "vpnsmgr")

add_executable(vpnsmgr WIN32 vpnsmgr.c vpnsmgr.rc)

get_filename_component(COMPONENT_FILE_NAME vpnsmgr NAME)
set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
target_sources(vpnsmgr PRIVATE "vpnsmgr.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
  target_sources(vpnsmgr PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
else()
  target_sources(vpnsmgr PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
endif()

set_target_properties(vpnsmgr
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

target_link_libraries(vpnsmgr cedar mayaqua)

=== src/vpntest/CMakeLists.txt ===
set(COMPONENT_NAME "Testing Utility")
set(COMPONENT_INTERNAL_NAME "vpntest")

add_executable(vpntest vpntest.c vpntest.h)

set_target_properties(vpntest
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  RUNTIME_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
)

if(WIN32)
  set_target_properties(vpntest
    PROPERTIES
    PDB_OUTPUT_DIRECTORY "${BUILD_DIRECTORY}"
  )

  get_filename_component(COMPONENT_FILE_NAME vpntest NAME)
  set(COMPONENT_FILE_NAME "${COMPONENT_FILE_NAME}.exe")

  configure_file("${TOP_DIRECTORY}/src/BuildFiles/VerScript/ver.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")
  target_sources(vpntest PRIVATE "vpntest.rc" "${CMAKE_CURRENT_BINARY_DIR}/ver.rc")

  if(${COMPILER_ARCHITECTURE} STREQUAL "x64")
    target_sources(vpntest PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x64_user.manifest")
  else()
    target_sources(vpntest PRIVATE "${TOP_DIRECTORY}/src/BuildFiles/Manifests/x86_user.manifest")
  endif()
endif()

target_link_libraries(vpntest cedar mayaqua)

=== debian/changelog ===
softether-vpn (5.01.9674+git20200806+8181039+dfsg3-1) unstable; urgency=medium

  * Reinstate the nodejs package which is needed for webui.
  * Ship the nodejs module in softether-common.
  * Move files to /usr using dh-sequence-movetousr.
  * Clean more generated files (Closes: #1046656).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 14 Jun 2024 09:44:17 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Andrej Shadura <andrewsh@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
+ dh-sequence-movetousr,
  cmake,
  libncurses5-dev,
  libreadline-dev,
@@ -119,6 +120,7 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Section: net
+Provides: node-vpnrpc
 Description: multiprotocol VPN program (common files)
  SoftEther is an open-source cross-platform multi-protocol VPN program.
  .
